package com.agiledeveloper;

import javax.script.*;

public class InvokeFunction {
  public static void main(String[] args) {
    ScriptEngineManager manager = new ScriptEngineManager();
    
    ScriptEngine engine = manager.getEngineByName("groovy");

    try {
      engine.eval(
        "def greet(name)" +
        "{" +
        "  println \"Hello ${name}\"\n" +
        " 'Thanks for calling Groovy'" +
        " }");
      
      Invocable invocable = (Invocable) engine;

      try {
        Object result = invocable.invokeFunction("greet", "Dan");
      
        System.out.println("Back in Java: " + result);
      } catch(NoSuchMethodException ex) {
        System.out.println(ex);
      }
    } catch(ScriptException ex) {
      System.out.println(ex);
    }
  }
}
