package com.agiledeveloper;

import javax.script.*;

public class InvokeMethod {
  public static void main(String[] args) {
    ScriptEngineManager manager = new ScriptEngineManager();
    
    ScriptEngine engine = manager.getEngineByName("groovy");

    try {
      engine.eval(
        "class Foo" +
        "{" +
        "  def bar(val)" +
        "  {" +
        "    println \"got ${val}\"" +
        "  }\n" +
        "  def static bar2(val)" +
        "  {" +
        "    println \"got ${val}!\"" +
        "  }" +
        "}\n" +
        "" +
        "def getFoo() { new Foo() }\n" +
        "def getFooClass() { Foo.class }");
      
      Invocable invocable = (Invocable) engine;
      Object foo = invocable.invokeFunction("getFoo");
      
      invocable.invokeMethod(foo, "bar", "Groovy?");
      
      Object fooClass = invocable.invokeFunction("getFooClass");
      invocable.invokeMethod(fooClass, "bar2", "Groovy?");
    } catch(NoSuchMethodException ex) {
      System.out.println(ex);
    } catch(ScriptException ex) {
      System.out.println(ex);
    }
  }
}
